From 7b2099f0d0a6a1ce7493448f40eba99506b662cd Mon Sep 17 00:00:00 2001
From: Shubham Khanna <khannashubham1197@gmail.com>
Date: Wed, 20 Mar 2024 09:38:42 +0530
Subject: [PATCH v31 4/4] Specify database along with subscription query.

Specify database along with subscription query.
---
 src/bin/pg_basebackup/pg_createsubscriber.c | 9 ++++++---
 1 file changed, 6 insertions(+), 3 deletions(-)

diff --git a/src/bin/pg_basebackup/pg_createsubscriber.c b/src/bin/pg_basebackup/pg_createsubscriber.c
index 34ec7c8505..975d081cae 100644
--- a/src/bin/pg_basebackup/pg_createsubscriber.c
+++ b/src/bin/pg_basebackup/pg_createsubscriber.c
@@ -1631,9 +1631,12 @@ set_replication_progress(PGconn *conn, struct LogicalRepInfo *dbinfo, const char
 	Assert(conn != NULL);
 
 	appendPQExpBuffer(str,
-					  "SELECT oid FROM pg_catalog.pg_subscription "
-					  "WHERE subname = '%s'",
-					  dbinfo->subname);
+					  "SELECT oid FROM pg_catalog.pg_subscription s \n"
+					  "WHERE subname = '%s' \n"
+					  "AND s.subdbid = (SELECT oid FROM pg_catalog.pg_database\n"
+					  "WHERE datname = '%s')",
+					  dbinfo->subname,
+					  dbinfo->dbname);
 
 	res = PQexec(conn, str->data);
 	if (PQresultStatus(res) != PGRES_TUPLES_OK)
-- 
2.34.1

